## maas 2.0.0~beta3+bzr4941

=== debian/changelog ===
maas (2.0.0~beta3+bzr4941-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 beta 3 bzr4941 (Standing FFe LP: #1553261)
  * Remove some leftover references to Cluster.
  * Run debconf-updatepo.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 20 Apr 2016 13:21:39 -0400

maas (2.0.0~beta2+bzr4920-0ubuntu2) xenial; urgency=medium

  * debian/control: Add missing dep on python3-httplib2

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 15 Apr 2016 22:23:55 -0400

maas (2.0.0~beta2+bzr4920-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 beta 2 bzr4920 (Standing FFe LP: #1553261)
  * Only create the squid cache if we have a configuration file.
    LP: #1568847
  * Re-add shared debconf templates.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 07 Apr 2016 18:22:00 -0400

maas (2.0.0~beta1+bzr4873-0ubuntu2) xenial; urgency=medium

  * Add maas-region-udeb and maas-rack-udeb to be used as part of the
    Ubuntu Server Installer (LP: #1561954)
    - ensure maas-rack-controller and maas-region-controller can be fully
      preseeded.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 05 Apr 2016 17:02:32 -0400

maas (2.0.0~beta1+bzr4873-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 beta 1 bzr4873 (Standing FFe LP: #1553261)
    - DHCP Snippets WebUI.
    - Ensure proxy configuration ACL's subnets MAAS knows about.
    - DNS High Availability.
  * debian/control: Move 'maascli' package install to
    python3-maas-client (LP: #1563859)
  * Improve way on how upgrades ensures correct permissions
    and ownership (LP: #1563799 , LP: #1563779)
  * Improve the way how removals clean the system (LP: #1563337)
  * Reflect new names and website for systemd units (LP: #1563807)
  * maas-proxy now uses a custom-built config, instead of a boilerplate.
    LP: #1379567

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 28 Mar 2016 16:47:58 -0400

maas (2.0.0~alpha4+bzr4843-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 alpha 4 bzr4843 (Standing FFe LP: #1553261)
    - DHCP Snippets backend and API.
    - Rack controller WebUI Served VLANs & Service Tracking
    - Rsyslog during enlistment/commissioning.
  * Ensure /etc/maas/templates/power gets removed on upgrade
  * debian/control: Update homepage and package descriptions.
    (LP: #1562036, LP: #1562034, LP: #1562062)
  * Rename maas-reigon-controller-min to maas-region-api (LP: #1562069)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 23 Mar 2016 12:27:27 -0400

maas (2.0.0~alpha3+bzr4810-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 bzr 4810 (Standing FFe LP: #1553261)
    - New Networks WebUI
      + Add Fabrics and Spaces details page.
      + Actions to Add/Remove Fabrics, VLANs, Spaces, Subnets.
    - Storage WebUI
      + Mount options
      + Swap Partitions
    - WebUI to change a Machine's domain.
    - Rack Controller details page now shows 'Server VLANs'
    - Add maas-rack support-dump command.
    - Fixes:
      + python3-maas-client API 2.0 no loger use op but MAASClient.post
        requires it (LP: #1555393)
      + Fail to commission when Fabric on Machine Interface doesn't match
        Rack Controller Fabric. (LP: #1554566)
      + TFTP back-end crashes (LP: #1553848)
      + Can't deploy a node, no interfaces on rack controller (LP: #1554999)
  * Update dhcpd permissions to conform with most recent paranoia described
    on LP: 1543794, so capability dac_override is not granted.
  * Update versioned depend on isc-dhcp-server

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 14 Mar 2016 18:34:53 -0400

maas (2.0.0~alpha2+bzr4776-0ubuntu1) xenial; urgency=medium

  * New usptream release, 2.0.0 bzr 4776 (LP: #1553261).
  * maas-dns Depends: bind9 >= 1:9.10.3.dfsg.P2-5 for better system time.
    LP: #1553176.
  * debian/extras/maas-{region,rack}: Replace maas-region-admin
    and maas-provision, respectively (LP: #1553791)
  * debian/maas-region-controller.postrm: Correctly handle removal by
    dbconfig-common. (LP: #1553648)
  * debian/extras/99-maas-region-sudoers: Allow running systemctl for
    bind9 and maas-proxy to support service tracking. (LP: #1555308)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 01 Feb 2016 18:18:52 +0100

maas (2.0.0~alpha1+bzr4736-0ubuntu1) xenial; urgency=medium

  * New usptream release, 2.0.0 bzr 4736 (LP: #1553261):
    - Deprecate Cluster Controllers in favor of Rack Controllers.
    - Deprecate API 1.0 in favor if API 2.0.
    - DHCP & Rack Controller High Availability.
    - Networking - IP Ranges.
    - Networking - DNS.
    - BMC Model.
  * Rename maas-cluster* to maas-rack* and handle the upgrade path.
  * Fix installation of init scripts and daemon systemd units.
  * Allow 'dhcpd' to access /usr/sbin/maas-provision via
    sudoers file (LP: #1552775)
  * debian/extras/maas: Replace shell wrapper with python. (LP: #1553605)
  * debian/control: Depends on iproute2 instead. (LP: #1553647)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 01 Feb 2016 18:18:52 +0100

maas (1.10.0+bzr4572-0ubuntu2) xenial; urgency=medium

  * debian/maas-region-controller.config: Ensure we truly preseed db
    setting so we always use localhost and it never asks the user.
  * debian/control: Suggests on python3-pyvmomi

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 01 Feb 2016 17:04:27 +0100

maas (1.10.0+bzr4572-0ubuntu1) xenial; urgency=medium

  * New upstram release, 1.10.0 bzr 4572:
    - Support python3, drop support for python2.
    - Support django 1.8+.
  * debian/control:
    - Remove all Upstart related services.
    - Remove python-django16 dependency.
    - Add python-petname dependency.
    - Change dependency python-django-piston to python-django-piston3.
    - Depends on dbconfig-pgsql instead of dbconfig-common.
  * debian/maas-region-controller.config:
    - Preseed dbconfig common to not ask for PG server to use.
  * debian/maas-region-controller-min.maas-regiond-worker@.service: Don't

